
#
#   THIS FILE IS UNDER RCS - DO NOT MODIFY UNLESS YOU HAVE
#   CHECKED IT OUT USING THE COMMAND CHECKOUT.
#
#    $Id: makefile.sol,v 1.0  2010/06/10 18:00:00  JMS Exp $
#
#     Revision 1.0  2010/06/10 18:00:00  JMS
#     Initial revision
#	Based on carlsubtrig module
#
#
#

CFLAGS=${GLOBALFLAGS} -g

B = $(EW_HOME)/$(EW_VERSION)/bin
L = $(EW_HOME)/$(EW_VERSION)/lib

CTOBJS = cmprscn.o \
     cont_trig.o \
	 initpars.o \
	 initsta.o \
	 prodtrig.o \
	 readcnfg.o \
	 readewh.o \
	 readstas.o \
	 sbntthrd.o \
     statrpt.o \
	 $L/chron3.o \
	 $L/getutil.o \
	 $L/kom.o \
	 $L/logit_mt.o \
     $L/sema_ew.o \
	 $L/sleep_ew.o \
	 $L/swap.o \
	 $L/time_ew.o \
     $L/threads_ew.o \
	 $L/transport.o

cont_trig: $(CTOBJS)
	cc -o $(B)/cont_trig $(CTOBJS) -lthread -lm -lposix4

lint:
	lint cmprscn.c cont_trig.c initpars.c initsta.c \
			prodtrig.c readcnfg.c readewh.c \
			readstas.c sbntthrd.c \
			statrpt.c  $(GLOBALFLAGS)

# Clean-up rules
clean:
	rm -f a.out core *.o *.obj *% *~

clean_bin:
	rm -f $B/cont_trig*


.c.o:
	cc -c $(CFLAGS) $<

cont_trig.o: cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h 
cont_trig.o: ${EW_HOME}/${EW_VERSION}/include/transport.h
cmprscn.o: cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h
initpars.o:  cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h
initsta.o:  cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h
prodtrig.o:  cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h 
prodtrig.o: ${EW_HOME}/${EW_VERSION}/include/time_ew.h
prodtrig.o: ${EW_HOME}/${EW_VERSION}/include/transport.h
readcnfg.o: cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h 
readcnfg.o: ${EW_HOME}/${EW_VERSION}/include/kom.h
readewh.o: cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h
readstas.o: cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h
sbntthrd.o: cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h 
sbntthrd.o: ${EW_HOME}/${EW_VERSION}/include/transport.h
sbntthrd.o: ${EW_HOME}/${EW_VERSION}/include/time_ew.h
statrpt.o: cont_trig.h ${EW_HOME}/${EW_VERSION}/include/earthworm.h 
statrpt.o: ${EW_HOME}/${EW_VERSION}/include/transport.h
