CFLAGS = ${GLOBALFLAGS}

B = $(EW_HOME)/$(EW_VERSION)/bin
L = $(EW_HOME)/$(EW_VERSION)/lib

FilterPickerDir = ./picker



O = pick_FP.o call_FilterPicker.o restart.o config.o stalist.o compare.o \
    index.o report.o initvar.o \
    $L/kom.o $L/getutil.o $L/time_ew.o $L/chron3.o $L/logit.o \
    $L/transport.o $L/sleep_ew.o $L/swap.o $L/trheadconv.o

picker_objs=FilterPicker5.o FilterPicker5_Memory.o PickData.o 

pick_FP: $O ${picker_objs}
	$(CC) -o $B/pick_FP $O ${picker_objs} -lm -lposix4

lint:
	lint pick_FP.c pick_ra.c restart.c config.c stalist.c \
			compare.c index.c sample.c report.c initvar.c \
			scan.c sign.c $(GLOBALFLAGS)

FilterPicker5.o: 
	$(CC) -c $(CFGLAGS) ${FilterPickerDir}/FilterPicker5.c

FilterPicker5_Memory.o: ${FilterPickerDir}/FilterPicker5_Memory.c
	$(CC) -c $(CFGLAGS) ${FilterPickerDir}/FilterPicker5_Memory.c

PickData.o: ${FilterPickerDir}/PickData.c
	$(CC) -c $(CFGLAGS) ${FilterPickerDir}/PickData.c

# Clean-up rules
clean:
	rm -f a.out core *.o *.obj *% *~

clean_bin:
	rm -f $B/pick_FP*
